// 
#ifndef _MEASURE
#define _MEASURE

interrupt void cpu_timer1_isr_SENS(void);

void Init_sensors(void);
void Init_sensors_more(void);
void Init_packMask(void);
void Temper_count(int chan);
void Current_count(int chan);
void Power_count(int chan);
void calc_sensor_koef(void);
void Is_Voltage_Hi(void);
void calc_volta_edge(void);

int er_anal(int term, long * count, long edge, int pre);


typedef union
{
	struct
	{
		unsigned int Tear	:1;
		unsigned int res	:1;
		unsigned int Wry	:1;
		unsigned int Out	:1;
		unsigned int Over	:1;
		unsigned int Hyper	:1;
		unsigned int Contr	:1;
		unsigned int res2	:1;

		unsigned int Stop	:1;
		unsigned int Ready	:1;
		unsigned int Discr1	:1;
		unsigned int Discr2	:1;
		unsigned int Discr3	:1;
		unsigned int Discr4	:1;
		unsigned int Ignor	:1;
		unsigned int Bypas	:1;

	} bit;
	unsigned int all;

} ERROR;

typedef union
{
	struct
	{
		unsigned int Error		:1;
		unsigned int Alarm		:1;
		unsigned int OverHeat	:1;
		unsigned int SubHeat	:1;
		unsigned int OutHeat	:1;
		unsigned int Test_lamp	:1;

	} bit;
	unsigned int all;

} FLAG;

#define NOER	0xE000//C
#define EROR	0x01FF

#define READY_FREQ	(500.0	* 2)// 
#define BLINK_FREQ	2		// 
#define	BLINK_TIME (READY_FREQ / BLINK_FREQ)

#define CANPOWSE 20

#define ADC_FREQ	3750 //3885.0//777//2000//20000	//777	//3885	//  (777*5)
#define DAC_FREQ	200//5		// 

#define LOAD_TIME	30//15		// sec

extern unsigned int Caliber_time;

#define SENS_ERR_WAIT	10

#define maximum_bright	10

#define Pi		3.1415926535897932384626433832795
#define Pi_2	1.5707963267948966192313216916398

#define ZERO	27

#define	Cooling		5		// ()    

#define COSPi6	0.86602540378443864676372317075294

#define RADIX2	1.4142135623730950488016887242097

#define POWER_380	0	//  380
#define POWER_38O	1	//  380

#define	CURRENT		2	// 
#define	VOLTAGE		3	// 

#define POWER_31	4	//  31
#define POWER_27	5	//  24
#define POWER_24	6	//  24
#define POWER_15	7	//  15
#define TERMO_AD	8	//  

extern int TPL_CANS,tpl_cans;

extern int READY, WAKE;

extern FILTERBAT filter[];
extern FILTERBAT adc_filter[];
extern FILTERBAT out_filter[];

extern int sens_type[];

extern unsigned long Lonely;
extern unsigned int CanPowse,CanGO;
extern unsigned int Maska[][8];

#endif 	//_MEASURE
